#include "stm32f4xx.h"
#include "stm32f4xx_conf.h"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "os_port.h"

#include "rampabus.h"
#include "Com_Uart.h"
//#include "Lectura_ADC.h"
#include "Herramienta.h"
#include "debug.h"


const uint8_t NORMAL=0x5a;
const uint8_t DEL=0x5b;
const uint8_t CAB_INI=0x55;
const uint8_t CAB_FIN=0x56; 

const uint32_t OFFSET_INI_FILE=100;
const uint32_t OFFSETCUR1_VAR=10;
const uint32_t OFFSETCUR2_VAR=15;


CapFile Fi_ini,Fi_cur,Fi_fin;
uint32_t toff;
FIL hfile;

CapIdx Idx_INI,Idx_FIN, Idx_CUR;
FIL HIdx;
TipoIdx TIdx;

uint8_t (*RBUS_Funcion[MAX_FUNCION])(void);
uint8_t INFUC=0;

uint8_t Capsula_Igual(Capsula A,Capsula B){
		if(A.Direccion==B.Direccion && A.Funcion==B.Funcion &&
			  A.Grupos==B.Grupos && A.Normas==B.Normas &&
			  A.Tamdatas==B.Tamdatas){
					
				return 1;	
		}
		else return 0;
}
void Proceder_Funcion(void){
	RBUS_Funcion[0]=RBUS_Vacio;
	RBUS_Funcion[1]=RBUS_ResPing;
	RBUS_Funcion[2]=RBUS_ObtenerDatos;
	RBUS_Funcion[3]=RBUS_Prueba;
	
}
void LimpiarCapsula(void){
	memset((uint8_t*)cap_data.Data,0,sizeof(cap_data.Data));
}
void RampaBus_Funcion(uint8_t fun){
	
	
}
//***************************************************************


uint8_t CargarArchivo(const char* path,FIL *fil){
	uint32_t disfil;
	uint32_t wes;
	
	error_t  fres;
	bool_t bfil;
	
	fres=fsChDir("bdata");
	if(fres!=FR_OK){
		TRACE_ERROR("Error al cambiar directorio\r\n");
		
		return 0;
	}
	
	bfil=fsFileExists(path);
	
	if(bfil){
		fsOpen_File(fil,path,FA_READ|FA_WRITE|FA_OPEN_EXISTING);
		fsSeekFile(fil,OFFSET_INI_FILE,FS_SEEK_SET);
		TRACE_ERROR("El archivo existe\r\n");
		return 1;
	
	}
	else{
		TRACE_ERROR("El archivo noooo existe\r\n");
		fsOpen_File(fil,path,FA_READ|FA_WRITE|FA_OPEN_ALWAYS);
		
			fsSeekFile(fil,OFFSET_INI_FILE,FS_SEEK_SET);
			disfil=fsTell(fil);
			
			Fi_ini.ant=OFFSET_INI_FILE;
			Fi_ini.attr=CAB_INI;
			Fi_ini.tam=sizeof(Fi_ini);
			Fi_ini.sig=disfil+Fi_ini.tam;
			
			Fi_fin.ant=disfil;
			Fi_fin.attr=CAB_FIN;
			Fi_fin.tam=sizeof(Fi_fin);
			Fi_fin.sig=NULL;
			
			fsWriteFile(fil,&Fi_ini,sizeof(Fi_ini));
			fsWriteFile(fil,&Fi_fin,sizeof(Fi_fin));
			disfil=disfil+Fi_ini.tam;
			fsSync(fil);
			fsSeekFile(fil,OFFSETCUR1_VAR,FS_SEEK_SET);
			fsWriteFile(fil,&disfil,sizeof(disfil));
			fsSync(fil);
			fsSeekFile(fil,OFFSETCUR2_VAR,FS_SEEK_SET);
			fsWriteFile(fil,&disfil,sizeof(disfil));
			
			fsSync(fil);
			TRACE_ERROR("Se creo  o abrio el archivo correctamente\r\n");
			return 1;
	}
	
	
}

void AgregarTarea(void *tarea,uint16_t tam){
	uint32_t cur;
	uint32_t res,wes,off_fin;
	CapFile rfi,CaF;
	
	fsSeekFile(&hfile,OFFSETCUR1_VAR,FS_SEEK_SET);
	fsReadFile(&hfile,&cur,sizeof(cur),&res);//leer el cursor actual
	fsSync(&hfile);
	
	fsSeekFile(&hfile,cur,FS_SEEK_SET);
	fsReadFile(&hfile,&rfi,sizeof(rfi),&res);
	fsSync(&hfile);
	
	fsSeekFile(&hfile,cur,FS_SEEK_SET);
	toff=fsTell(&hfile);
	
	CaF.ant=rfi.ant;
	CaF.attr=NORMAL;
	CaF.sig=cur+sizeof(CaF)+tam;
	CaF.tam=tam;
	
	fsWriteFile(&hfile,&CaF,sizeof(CaF));
	fsWriteFile(&hfile,tarea,tam);
	fsSync(&hfile);
	
	off_fin=fsTell(&hfile);
	
	Fi_fin.ant=cur;
	Fi_fin.attr=CAB_FIN;
	Fi_fin.sig=NULL;
	Fi_fin.tam=sizeof(Fi_fin);
	
	fsWriteFile(&hfile,&Fi_fin,sizeof(Fi_fin));
	fsSync(&hfile);
	
	fsSeekFile(&hfile,OFFSETCUR2_VAR,FS_SEEK_SET);
	fsWriteFile(&hfile,&off_fin,sizeof(off_fin));
	fsSync(&hfile);
	
	fsSeekFile(&hfile,OFFSETCUR1_VAR,FS_SEEK_SET);
	fsWriteFile(&hfile,&CaF.sig,sizeof(CaF.sig));
	fsSync(&hfile);
		
}

void LeerCapFileTarea(CapFile *fi){
	uint32_t res;
	fsReadFile(&hfile,fi,sizeof(CapFile),&res);
	fsSync(&hfile);
}
uint8_t TNV_Sig(void){
	uint32_t off;
	off=fsTell(&hfile);
	
	LeerCapFileTarea(&Fi_cur);
	if(Fi_cur.attr!=CAB_FIN){
		fsSeekFile(&hfile,Fi_cur.sig,FS_SEEK_SET);
		toff=Fi_cur.sig;
		return 1;
		
	}
	else{
		fsSeekFile(&hfile,off,FS_SEEK_SET);
		return 0;
	}
}
uint8_t TNV_Ant(void){
	uint32_t off;
	off=fsTell(&hfile);
	
	LeerCapFileTarea(&Fi_cur);
	if(Fi_cur.attr!=CAB_INI){
		fsSeekFile(&hfile,Fi_cur.ant,FS_SEEK_SET);
		toff=Fi_cur.ant;
		return 1;
	}
	else{
		fsSeekFile(&hfile,off,FS_SEEK_SET);
		return 0;
	}
}
void TNV_ObtenerTarea(void *tarea,CapFile *fi){
	uint32_t res, off;
	off=fsTell(&hfile);
	
	fsReadFile(&hfile,fi,sizeof(CapFile),&res);
	fsSync(&hfile);
	if(fi->attr==NORMAL){
		if(fi->tam>0){
			fsReadFile(&hfile,tarea,fi->tam,&res);
			fsSync(&hfile);
		}
	}
	else{
		memset(tarea,0,50);
	}
	fsSeekFile(&hfile,off,FS_SEEK_SET);
	
}
void TNV_Cabecera_INI_FIN(uint8_t fin){
	uint32_t val1,res;
	
	if(fin){
		fsSeekFile(&hfile,OFFSETCUR2_VAR,FS_SEEK_SET);
		fsReadFile(&hfile,&val1,sizeof(val1),&res);
		fsSync(&hfile);
		
		fsSeekFile(&hfile,val1,FS_SEEK_SET);
		toff=val1;
		
	}
	else{
		fsSeekFile(&hfile,OFFSET_INI_FILE,FS_SEEK_SET);
		toff=OFFSET_INI_FILE;
	}
	
}
void TNV_SeekOff(uint32_t off){
	fsSeekFile(&hfile,off,FS_SEEK_SET);
	
}
//------------------------------------------------------------------------
void CargarArchivoIdx(TipoIdx tidx){
	const char *file[]={"DIR_IDX.idx",
											"GRU_IDX.idx",
											"FUN_IDX.idx",
											"ELI_IDX,idx"};
	
	
	uint32_t disfil;
	uint32_t wes;
	
	error_t  fres;
	bool_t bfil;
	uint16_t Num_item=0;
	
	fres=fsChDir("bdata");
	if(fres!=FR_OK){
		TRACE_ERROR("Error al cambiar directorio\r\n");
		
		return ;
	}
	
	bfil=fsFileExists(file[tidx]);
	
	if(bfil){
		fsOpen_File(&HIdx,file[tidx],FA_READ|FA_WRITE|FA_OPEN_EXISTING);
		fsSeekFile(&HIdx,OFFSET_INI_FILE,FS_SEEK_SET);
		TRACE_ERROR("El archivo existe en IDX\r\n");
		return ;
	
	}
	else{
		TRACE_ERROR("El archivo noooo existe en IDX\r\n");
		fsOpen_File(&HIdx,file[tidx],FA_READ|FA_WRITE|FA_OPEN_ALWAYS);
		
			fsSeekFile(&HIdx,OFFSET_INI_FILE,FS_SEEK_SET);
			disfil=fsTell(&HIdx);
			
			Idx_INI.atr=IDX_INICIO;
			Idx_INI.id=0;
			Idx_INI.ant=OFFSET_INI_FILE;
			Idx_INI.sig=NULL;
			//Idx_INI.tam=0;
			Idx_INI.tareaoffini=NULL;
		
			Idx_FIN.atr=IDX_FIN;
			Idx_FIN.id=0;
			Idx_FIN.ant=OFFSET_INI_FILE;
			Idx_FIN.sig=116;
			//Idx_FIN.tam=0;
			Idx_FIN.tareaoffini=NULL;
		
			Idx_INI.sig=disfil+sizeof(Idx_INI);
			Idx_FIN.ant=disfil;
			
			fsWriteFile(&HIdx,&Idx_INI,sizeof(Idx_INI));
			fsWriteFile(&HIdx,&Idx_FIN,sizeof(Idx_FIN));
			//disfil=disfil+Fi_ini.tam;
			fsSync(&HIdx);
			fsSeekFile(&HIdx,OFFSETCUR1_VAR,FS_SEEK_SET);
			fsWriteFile(&HIdx,&Num_item,sizeof(Num_item));
			fsSync(&HIdx);
			
			TRACE_ERROR("Se creo  o abrio el archivo correctamente\r\n");
			return ;
	}
	
	
}


//**********************************************************************
void PulgarRed(void){
	uint8_t cad[5]={0x1,0x1,0x1,0x1,0x1};
	ActivarEnvio();
	sleep(30);
	SendDmaTx(cad,5);
	sleep(30);
	DesactivarEnvio();
	sleep(30);
}


uint8_t RBUS_Vacio(void){
	INFUC=0;
	return 0;
}
uint8_t RBUS_ResPing(void){
	
	
	uint16_t Res=PINGDAT;
	GPIO_WriteBit(GPIOA,GPIO_Pin_8,Bit_SET);
	//Delay(40);
	sleep(40);
	
	SendDmaTx((uint8_t*)&Res,Multiplo(sizeof(Res),5));
	//SendDmaTx((uint8_t*)&Res,2);
	
	GPIOB->ODR^=GPIO_Pin_8;
	//Delay(40);
	sleep(40);
	GPIO_WriteBit(GPIOA,GPIO_Pin_8,Bit_RESET);
	LimpiarCapsula();
	//RBUS_Vacio();
	INFUC=0;
	return 0;

}

uint8_t RBUS_ObtenerDatos(void){
	
	uint16_t cur=0;
	Capsula cap;
	uint16_t tam_t;
	
	cap.Direccion=DIR;
	cap.Funcion=2;
	cap.Grupos=esclavo;
	cap.Normas=final;
	cap.Tamdatas=6;
	
		
	MemSecuencial(TX_Buf,&cap,sizeof(cap),&cur);
//	MemSecuencial(TX_Buf,ADC1_Buf,6,&cur);
	GPIO_WriteBit(GPIOA,GPIO_Pin_8,Bit_SET);
	//Delay(40);
	sleep(40);
	
	tam_t=Multiplo(cur,5);
	SendDmaTx(TX_Buf,tam_t);
		
	//Delay(40);
	sleep(40);
	GPIO_WriteBit(GPIOA,GPIO_Pin_8,Bit_RESET);
	LimpiarCapsula();
	INFUC=0;
	
	
	return 0;
	
}

uint8_t RBUS_Prueba(void){
	
	uint16_t con2;
	//GPIOB->ODR^=GPIO_Pin_8;
	//memcpy((uint16_t*)con1,(uint8_t*)RX_Buf,2);
	
	DesModularMem(&con2,RX_Buf,2,0);
	
	
	while(con2--){
		GPIOB->ODR^=GPIO_Pin_9;
		//Delay(100);
		sleep(100);
		
	}
	Config_USART3_DMA_RX(5);
	LimpiarCapsula();
	INFUC=0;
	return 0;
}
